searchData={"items":[{"type":"module","title":"ExESDB","doc":"ExESDB is a wrapper around the khepri library. \n  Its intention is to provide an interface to khepri,\n  with a focus on event sourcing.","ref":"ExESDB.html"},{"type":"module","title":"ExESDB.App","doc":"This module is used to start the ExESDB system.","ref":"ExESDB.App.html"},{"type":"function","title":"ExESDB.App.handle_info/2","doc":"","ref":"ExESDB.App.html#handle_info/2"},{"type":"module","title":"ExESDB.EnVars","doc":"This module contains the environment variables that are used by ExESDB","ref":"ExESDB.EnVars.html"},{"type":"function","title":"ExESDB.EnVars.data_dir/0","doc":"Returns the data directory. default: `/data`","ref":"ExESDB.EnVars.html#data_dir/0"},{"type":"function","title":"ExESDB.EnVars.db_type/0","doc":"Returns the db type. `single` or `cluster`. default: `single`","ref":"ExESDB.EnVars.html#db_type/0"},{"type":"function","title":"ExESDB.EnVars.pub_sub/0","doc":"Returns the name of the pub/sub. default: `ex_esdb_pub_sub`","ref":"ExESDB.EnVars.html#pub_sub/0"},{"type":"function","title":"ExESDB.EnVars.seed_nodes/0","doc":"Returns the seed nodes. default: `nil`","ref":"ExESDB.EnVars.html#seed_nodes/0"},{"type":"function","title":"ExESDB.EnVars.store_id/0","doc":"Returns the khepri store id. default: `ex_esdb_store`","ref":"ExESDB.EnVars.html#store_id/0"},{"type":"function","title":"ExESDB.EnVars.timeout/0","doc":"Returns the timeout in milliseconds. default: `10_000`","ref":"ExESDB.EnVars.html#timeout/0"},{"type":"module","title":"ExESDB.EventStore","doc":"A GenServer wrapper around :khepri to act as an event store.\nInspired by EventStoreDB's API.","ref":"ExESDB.EventStore.html"},{"type":"function","title":"ExESDB.EventStore.append_to_stream/4","doc":"Append events to a stream.","ref":"ExESDB.EventStore.html#append_to_stream/4"},{"type":"function","title":"Parameters - ExESDB.EventStore.append_to_stream/4","doc":"- `stream_id`: The id of the stream to append to.\n  - `expected_version`: The expected version of the stream (for optimistic concurrency).\n  - `events`: A list of events to append.","ref":"ExESDB.EventStore.html#append_to_stream/4-parameters"},{"type":"function","title":"Returns - ExESDB.EventStore.append_to_stream/4","doc":"- `{:ok, new_stream_version}` if successful.\n  - `{:error, reason}` if unsuccessful.","ref":"ExESDB.EventStore.html#append_to_stream/4-returns"},{"type":"function","title":"ExESDB.EventStore.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExESDB.EventStore.html#child_spec/1"},{"type":"function","title":"ExESDB.EventStore.get_state/1","doc":"Get the current state of the store.","ref":"ExESDB.EventStore.html#get_state/1"},{"type":"function","title":"Parameters - ExESDB.EventStore.get_state/1","doc":"- `store`: The store to get the state of.","ref":"ExESDB.EventStore.html#get_state/1-parameters"},{"type":"function","title":"Returns - ExESDB.EventStore.get_state/1","doc":"- `{:ok, state}`  if successful.\n    - `{:error, reason}` if unsuccessful.","ref":"ExESDB.EventStore.html#get_state/1-returns"},{"type":"function","title":"ExESDB.EventStore.get_streams/1","doc":"Get the list of streams in the store.","ref":"ExESDB.EventStore.html#get_streams/1"},{"type":"function","title":"Parameters - ExESDB.EventStore.get_streams/1","doc":"- `store`: The store to get the streams from.","ref":"ExESDB.EventStore.html#get_streams/1-parameters"},{"type":"function","title":"Returns - ExESDB.EventStore.get_streams/1","doc":"- `{:ok, streams}`  if successful.","ref":"ExESDB.EventStore.html#get_streams/1-returns"},{"type":"function","title":"ExESDB.EventStore.read_stream_forward/4","doc":"Read events from a stream.","ref":"ExESDB.EventStore.html#read_stream_forward/4"},{"type":"function","title":"Parameters - ExESDB.EventStore.read_stream_forward/4","doc":"- `stream_name`: The name of the stream to read from.\n  - `start_version`: The version to start reading from.\n  - `count`: The number of events to read.","ref":"ExESDB.EventStore.html#read_stream_forward/4-parameters"},{"type":"function","title":"Returns - ExESDB.EventStore.read_stream_forward/4","doc":"- `{:ok, events}` if successful.\n  - `{:error, reason}` if unsuccessful.","ref":"ExESDB.EventStore.html#read_stream_forward/4-returns"},{"type":"function","title":"ExESDB.EventStore.start_link/1","doc":"","ref":"ExESDB.EventStore.html#start_link/1"},{"type":"function","title":"ExESDB.EventStore.stream_version/2","doc":"Get the current version of a stream.","ref":"ExESDB.EventStore.html#stream_version/2"},{"type":"function","title":"Parameters - ExESDB.EventStore.stream_version/2","doc":"- `stream_name`: The name of the stream to check.","ref":"ExESDB.EventStore.html#stream_version/2-parameters"},{"type":"function","title":"Returns - ExESDB.EventStore.stream_version/2","doc":"- `{:ok, version}` if successful.\n  - `{:error, reason}` if unsuccessful.","ref":"ExESDB.EventStore.html#stream_version/2-returns"},{"type":"module","title":"ExESDB.EventStoreInfo","doc":"This module provides functions to get information about the EXESDB event store.","ref":"ExESDB.EventStoreInfo.html"},{"type":"function","title":"ExESDB.EventStoreInfo.get_streams!/1","doc":"Returns the list of streams in the store.","ref":"ExESDB.EventStoreInfo.html#get_streams!/1"},{"type":"function","title":"ExESDB.EventStoreInfo.get_streams_raw/1","doc":"","ref":"ExESDB.EventStoreInfo.html#get_streams_raw/1"},{"type":"module","title":"ExESDB.Messages","doc":"Messages are based on official proto file","ref":"ExESDB.Messages.html"},{"type":"type","title":"ExESDB.Messages.t/0","doc":"","ref":"ExESDB.Messages.html#t:t/0"},{"type":"module","title":"ExESDB.Options","doc":"This module contains the options helper functions for ExESDB","ref":"ExESDB.Options.html"},{"type":"function","title":"ExESDB.Options.app_env/0","doc":"","ref":"ExESDB.Options.html#app_env/0"},{"type":"function","title":"ExESDB.Options.app_env/1","doc":"","ref":"ExESDB.Options.html#app_env/1"},{"type":"function","title":"ExESDB.Options.data_dir/0","doc":"","ref":"ExESDB.Options.html#data_dir/0"},{"type":"function","title":"ExESDB.Options.db_type/0","doc":"","ref":"ExESDB.Options.html#db_type/0"},{"type":"function","title":"ExESDB.Options.pub_sub/0","doc":"","ref":"ExESDB.Options.html#pub_sub/0"},{"type":"function","title":"ExESDB.Options.seed_nodes/0","doc":"","ref":"ExESDB.Options.html#seed_nodes/0"},{"type":"function","title":"ExESDB.Options.store_id/0","doc":"","ref":"ExESDB.Options.html#store_id/0"},{"type":"function","title":"ExESDB.Options.sys_env/1","doc":"","ref":"ExESDB.Options.html#sys_env/1"},{"type":"function","title":"ExESDB.Options.timeout/0","doc":"","ref":"ExESDB.Options.html#timeout/0"},{"type":"module","title":"ExESDB.Repl","doc":"This module is used to start a REPL with the ExESDB.system running.","ref":"ExESDB.Repl.html"},{"type":"function","title":"ExESDB.Repl.all/1","doc":"","ref":"ExESDB.Repl.html#all/1"},{"type":"function","title":"ExESDB.Repl.append/2","doc":"","ref":"ExESDB.Repl.html#append/2"},{"type":"function","title":"ExESDB.Repl.get_config/0","doc":"","ref":"ExESDB.Repl.html#get_config/0"},{"type":"function","title":"ExESDB.Repl.get_streams/0","doc":"","ref":"ExESDB.Repl.html#get_streams/0"},{"type":"function","title":"ExESDB.Repl.initialize/1","doc":"","ref":"ExESDB.Repl.html#initialize/1"},{"type":"function","title":"ExESDB.Repl.start_monitor/1","doc":"","ref":"ExESDB.Repl.html#start_monitor/1"},{"type":"function","title":"ExESDB.Repl.store/0","doc":"","ref":"ExESDB.Repl.html#store/0"},{"type":"function","title":"ExESDB.Repl.stream1/0","doc":"","ref":"ExESDB.Repl.html#stream1/0"},{"type":"function","title":"ExESDB.Repl.stream2/0","doc":"","ref":"ExESDB.Repl.html#stream2/0"},{"type":"function","title":"ExESDB.Repl.stream3/0","doc":"","ref":"ExESDB.Repl.html#stream3/0"},{"type":"function","title":"ExESDB.Repl.stream4/0","doc":"","ref":"ExESDB.Repl.html#stream4/0"},{"type":"function","title":"ExESDB.Repl.stream5/0","doc":"","ref":"ExESDB.Repl.html#stream5/0"},{"type":"module","title":"ExESDB.System","doc":"This module is the top level supervisor for the ExESDB system.\n  It is responsible for supervising:\n  - the event store\n  - the cluster\n  - the Event Enitter (pub/sub)","ref":"ExESDB.System.html"},{"type":"function","title":"ExESDB.System.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExESDB.System.html#child_spec/1"},{"type":"function","title":"ExESDB.System.start_link/1","doc":"","ref":"ExESDB.System.html#start_link/1"},{"type":"module","title":"Flags","doc":"This module is used to manipulate bitwise flags.\n\n  Inspired by: [Flags in C#](https://stackoverflow.com/questions/8447/what-does-the-flags-enum-attribute-mean-in-c)\n  \n  Event souurced systems often rely on flags to indicate the state of the aggregate at any given time.\n  In this module, we define a set of functions that can be used to manipulate these flags.","ref":"Flags.html"},{"type":"function","title":"Flags.decompose/1","doc":"","ref":"Flags.html#decompose/1"},{"type":"function","title":"Flags.has?/2","doc":"","ref":"Flags.html#has?/2"},{"type":"function","title":"Flags.has_all?/2","doc":"","ref":"Flags.html#has_all?/2"},{"type":"function","title":"Flags.has_any?/2","doc":"","ref":"Flags.html#has_any?/2"},{"type":"function","title":"Flags.has_not?/2","doc":"","ref":"Flags.html#has_not?/2"},{"type":"function","title":"Flags.highest/2","doc":"","ref":"Flags.html#highest/2"},{"type":"function","title":"Flags.lowest/2","doc":"","ref":"Flags.html#lowest/2"},{"type":"function","title":"Flags.set/2","doc":"Returns the bitwise OR of two flags.\n  In other words, it sets the bit that corresopnds to the flag\n  GIVEN: original_state is `0b00100100` (integer: 36) \n  WHEN the flag to be set is `0b01000000` (integer: 64)\n  THEN the result is `0b01100100` (integer: 100)\n\n  Example:\n  iex> Flags.set(36, 64)\n  100","ref":"Flags.html#set/2"},{"type":"function","title":"Flags.set_all/2","doc":"Returns the bitwise OR of multiple flags against a given state.\n  In other words, it sets the bits that corresopnds to the flags\n  GIVEN: original_state is `0b00100100` (integer: 36)\n  WHEN the flags to be set are `[0b01000000, 0b10000000]` (integers: 64, 128)\n  THEN the result is `0b11100100` (integer: 228)\n\n  Example:\n  iex> Flags.set_all(36, [64, 128])\n  228","ref":"Flags.html#set_all/2"},{"type":"function","title":"Flags.to_list/2","doc":"","ref":"Flags.html#to_list/2"},{"type":"function","title":"Flags.to_string/2","doc":"","ref":"Flags.html#to_string/2"},{"type":"function","title":"Flags.unset/2","doc":"Returns the bitwise AND of two flags.\n  In other words, it unsets the bit that corresopnds to the flag\n  GIVEN: original_state is `0b01100100` (integer: 100)\n  WHEN the flag to be unset is `0b01000000` (integer: 64)\n  THEN the result is `0b00100100` (integer: 36)\n\n  Example:\n  iex> Flags.unset(100, 64)\n  36","ref":"Flags.html#unset/2"},{"type":"function","title":"Flags.unset_all/2","doc":"","ref":"Flags.html#unset_all/2"},{"type":"extras","title":"ADR","doc":"","ref":"adr.html"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"version 0.0.1-alpha - Changelog","doc":"","ref":"changelog.html#version-0-0-1-alpha"},{"type":"extras","title":"2025.03.25 - Changelog","doc":"- Initial release","ref":"changelog.html#2025-03-25"},{"type":"extras","title":"ExESDB Eventstore","doc":"# Getting Started with ExESDB, a BEAM-native Event Store","ref":"getting-started.html"},{"type":"extras","title":"Installation - ExESDB Eventstore","doc":"in your `mix.exs` file:\n\n```elixir\ndef deps do\n  [\n    {:ex_esdb, \"~> 0.0.2-alpha\"}\n  ]\nend\n```","ref":"getting-started.html#installation"},{"type":"extras","title":"Configuration - ExESDB Eventstore","doc":"1. in your `config/config.exs` file:\n\n```elixir\nconfig :ex_esdb, :khepri,\n  # the directory where the khepri store will be created\n  data_dir: \"/ex_esdb/data\",\n  # the id of the khepri store.\n  store_id: :ex_esdb_store,\n  # the type of database setup to use\n  db_type: :single,\n  # a global timeout in milliseconds\n  timeout: 10_000,\n  # a list of seed nodes to connect to\n  seed_nodes: [],\n  # the name of the pub/sub module to use\n  pub_sub: :ex_esdb_pub_sub\n\n```\n\n2. from the ENVIRONMENT:\n\n```bash\n\nexport EX_ESDB_DATA_DIR=/ex_esdb/data\nexport EX_ESDB_STORE_ID=ex_esdb_store\nexport EX_ESDB_DB_TYPE=single\nexport EX_ESDB_TIMEOUT=10000\nexport EX_ESDB_SEED_NODES=\nexport EX_ESDB_PUB_SUB=ex_esdb_pub_sub\n\n```","ref":"getting-started.html#configuration"},{"type":"extras","title":"Usage - ExESDB Eventstore","doc":"```elixir\ndefmodule MyApp.Application do\n  use Application\n\n  @impl true\n  def start(_type, _args) do\n    opts = ExESDB.Options.app_env()\n    children = [\n      {ExESDB,System, opts},\n    ]\n\n    opts = [strategy: :one_for_one, name: MyApp.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\n\nend\n```","ref":"getting-started.html#usage"},{"type":"extras","title":"Testing","doc":"","ref":"testing.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}